package com.autentia.tutoriales.spring.asynchronous;

import org.springframework.scheduling.annotation.*;
import org.springframework.stereotype.*;

@Service
public class AsynchronousService {

	private AsyncResult<String> result = new AsyncResult<String>("0 correos enviados");

	@Async
	public void sendMails(int totalMails) {
		for (int i = 1; i <= totalMails; i++) {
			try {
				sendMail(i);
				result = new AsyncResult<String>("Enviados " + i + " de " + totalMails);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	private void sendMail(int num) throws InterruptedException {
		Thread.sleep(1000);
		System.out.println("Mail " + num + " enviado.");
	}

	// @Scheduled(fixedDelay = 3000)
	public void logSendMailsState() {
		System.out.println(result.get());
	}

	public AsyncResult<String> getResult() {
		return result;
	}

	public String getMailsSender() {
		return result.get();
	}
}